//+------------------------------------------------------------------+
//|                                                       karkas.mq4 |
//|                      Copyright  2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//
extern int AllowToBuy1Sell2AllTrade3 = 3; // 1 -   , 2 -   , 3 -    
extern int noCloseOrdIfUbitok = 1; //1 -     0 -    

extern int p_stop_loss = 0; // -   (    ,      ),  0 - - 
extern int p_take_profit = 0; // take-profit -   ,      (  ,    ),  0,   

extern double priceToBuy_min = 0; //       
extern double priceToBuy_max = 114; //        
extern double priceToSell_min = 105; //       
extern double priceToSell_max = 300; //       

extern int minBarsToReshenie = 2000; // -   ,     
extern double volumeTorg = 0.1; // 
int MyMagic = 123456; //  ,   

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----  
   
   if (Bars >= minBarsToReshenie)
   {
      Print(" ");
   }
   else
   {
      Print(":    .");
   }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
 
//----
//    (   )

//,     -    
   bool isOpenOrderOnCurrentSymbol = false;
   
//    ()
   for (int i=0; i<=OrdersTotal()-1; i++)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
      {
         if (OrderSymbol()==Symbol()) //    
         {  
            if (OrderMagicNumber() == MyMagic)
            // -   ,         
            {
               isOpenOrderOnCurrentSymbol = true;         
               int doStop = 0;
            
               int signal = 0;
               if ((OrderType() == OP_BUY))
               {
                  signal = 1; //,     
               }
               if ((OrderType() == OP_SELL))
               {
                  signal = -1; //,     
               }
               
               
               
		//   -      - ,  doStop = 1;
               //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! doStop = 1;
               
               //
               if (doStop >= 1)
               {
                  if (noCloseOrdIfUbitok == 1)
                  {
                     if (OrderProfit()<0)
                     {
                        doStop = 0; //   
                        Print("    (. )!");
                     }
                  }
               }  
         
               if (doStop >= 1)
		// 
               {
                  bool b_close = false;
                        
                  if (OrderType() == OP_BUY)
                  {
                     b_close = OrderClose(OrderTicket(), OrderLots(), Bid, 5, CLR_NONE); 
                     //Bid -    (-  ).    
                  }
                  if (OrderType() == OP_SELL)
                  {
                     b_close = OrderClose(OrderTicket(), OrderLots(), Ask, 5, CLR_NONE);
                  }
                  int cod_err2 = GetLastError() ;
                  Print("  ", b_close, "  ", cod_err2);
               }
            }
         }
      }
   }
   
   // ,     
   isOpenOrderOnCurrentSymbol = false;   
   for (i=0; i<=OrdersTotal()-1; i++)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)==true)
      {
         if (OrderSymbol()==Symbol())
         {  
            if (OrderMagicNumber() == MyMagic)            
            {
               isOpenOrderOnCurrentSymbol = true;  // ,                
            }
         }
      }
   }
   
   //   
   double stop_loss = 0; //0     
   double take_profit = 0; //0     
   int err; // 
   int nomer_ticket;
   string ord_comment = ""; // 
   int want_to = 0; //,    . 1 - . -1 - . 0 -   
   
  
   if (!(isOpenOrderOnCurrentSymbol))
//  -       ,     
   {
//  .  want_to - ,    . 1 - . -1 - . 0 -   
      //!!!!!!!!!!!!!! want_to
      
      if (want_to == 1)
      {
         if (p_stop_loss > 0) //      -
         {
            stop_loss = NormalizeDouble(Bid-p_stop_loss*Point, Digits); //  -      -  ,    1 
	//,   ,           
         }
         if (p_take_profit > 0) //      -
         {
            take_profit = NormalizeDouble(Ask+p_take_profit*Point, Digits);
         }
      }
      if (want_to == -1)
      {
         if (p_stop_loss > 0) //      -
         {
            stop_loss = NormalizeDouble(Ask+p_stop_loss*Point, Digits);
         }
         if (p_take_profit > 0) //      -
         {
            take_profit = NormalizeDouble(Bid-p_take_profit*Point, Digits);
         }
      }
               
      //  
      if (want_to == 1)
      {         
         if ((AllowToBuy1Sell2AllTrade3 == 3)||(AllowToBuy1Sell2AllTrade3 == 1)) //        
         {     
            if ((Ask >= priceToBuy_min)&&(Ask <= priceToBuy_max)) //     
            {
               Print("   Buy ", Symbol(), "  ", Ask, "      SL ", NormalizeDouble(stop_loss, Digits), "      TP ", NormalizeDouble(take_profit, Digits));
               nomer_ticket = OrderSend(Symbol(), OP_BUY, volumeTorg, Ask, 0, NormalizeDouble(stop_loss, Digits), NormalizeDouble(take_profit, Digits), ord_comment, MyMagic, 0, Green);      
                   
               err = GetLastError();
               Print("   : ", nomer_ticket, "  : ", err);             
            }
         }
      }
      
      if (want_to == -1)
      {         
         if ((AllowToBuy1Sell2AllTrade3 == 3)||(AllowToBuy1Sell2AllTrade3 == 2)) //        
         {  
            if ((Bid >= priceToSell_min)&&(Bid <= priceToSell_max)) //     
            {             
               Print("   Sell ", Symbol(), "  ", Bid, "      SL ", NormalizeDouble(stop_loss, Digits), "      TP ", NormalizeDouble(take_profit, Digits));
               nomer_ticket = OrderSend(Symbol(), OP_SELL, volumeTorg, Bid, 0, NormalizeDouble(stop_loss, Digits), NormalizeDouble(take_profit, Digits), ord_comment, MyMagic, 0, Red);
               
               err = GetLastError();
               Print("   : ", nomer_ticket, "  : ", err);             
            }
         }
      }
      
      //
   }
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+